package org.greenstone.gsdl3.gs3build.schema;

import java.io.*;

import javax.xml.parsers.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class SchemaParser
{
	public SchemaParser(File file, String namespace)
	{
	  try {
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse(file);

			// TODO: get all the types in the tree

			// TODO: do a traverse, and thus cope with elements-within-elements if needsbe, but
			// this shouldn't happen except in a directly defined situation - actually doing the
			// parsing in part inside each node would work well provided one checked for a node
			// having already been done...
			System.out.println("Read");

			NodeList schemas = document.getElementsByTagName("xs:schema");
			if (schemas.getLength() == 0) {
				schemas = document.getElementsByTagName("xsd:schema");
			}
			if (schemas.getLength() == 0) {
				schemas = document.getElementsByTagName("schema");
			}

			System.out.println(" " + schemas.getLength() + " schemas");

			for (int s = 0; s < schemas.getLength(); s ++) {
				Schema schema = new Schema(schemas.item(s));
			}
		}
		catch (FactoryConfigurationError e) {
			System.out.println(e);
		}
		catch (ParserConfigurationException ex) {
			System.out.println(ex);
		}
		catch (SAXException ex) {
			System.out.println(ex);
		}
		catch (IOException ex) {
			System.out.println(ex);
		}
	}

	public static void main(String args[])
	{	try
		{	File file = new File(args[0]);

			SchemaParser parser = new SchemaParser(file, "");			
		}
		catch (Exception ex)
		{ System.out.println(ex);
		}
		return;
	}
}